' -----------------------------------------------------------------------------------------------------------
' ̃Tv́A}ʂɂ}igăAj[Vs܂B
' ̎ԂƂɁAzu}iړȂAC̕\Ԃ؂ւ邱Ƃ
' Aj[V̂悤ɌĂ܂B
' 
' Copyright 2008 TECHNICAL STAFF Corporation.
' -----------------------------------------------------------------------------------------------------------

Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports System.IO

Imports RootPro.RootProCAD.Proxy
Imports RootPro.RootProCAD.Proxy.Geometry

<CLSCompliant(False)> _
Public Class Form1

    ' uRootPro CADvAvP[V
    Private app As RootPro.RootProCAD.Proxy.Application

    Private currentAnimationIndex As Integer

    Private rpcdFilePath As String ' }ʃt@CpX
    Private fileExist As Boolean

    ' Ce[u
    Private layerTable As LayerTable

    ' JEg_Ep̃C
    Private countdownTextLayer As Layer
    ' ˑ̃C
    Private launchingPadLayer As Layer
    ' Pbg̃C
    Private rocket0Layer As Layer
    Private rocketLayer(1) As Layer
    ' ñC
    Private earthLayer As Layer

    Private countdownSecond As Integer = 4 ' JEg_E̎
    Private risingSecond As Integer = 16 ' Pbg㏸

    ' Aj[Vp̐}`
    Private countdownTextShape As TextShape
    Private rocketComponentShape(1) As DrawComponentShape


    Public Sub New(ByVal app As RootPro.RootProCAD.Proxy.Application)
        InitializeComponent()

        Me.app = app
    End Sub


    ''' <summary>
    ''' tH[̃[h̏
    ''' <summary>
    ''' <param name="sender"><param>
    ''' <param name="e"><param>
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' \[XɖߍłTvp̐}ʂ
        ' }ChLgɃt@CƂĕۑB
        ' iAj[VɎg}iȂǂ܂܂ꂽt@CŁÃt@CJĎg߁j
        ' Tvt@C
        Dim temporaryPath As String = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments)
        rpcdFilePath = temporaryPath + "\_RootProCADAddInSampleAnimationParts.rpcd"
        fileExist = File.Exists(rpcdFilePath)
        ' tH_ɃTvt@CȂꍇ
        If fileExist = False Then
            ' \[Xɖߍ񂾃Tvt@CoĎw肵pXɕۑ
            SaveAnimationPartsFile(rpcdFilePath)
        End If

        ' Tvt@CJ
        Dim doc As Document = app.Documents.Open(rpcdFilePath)
    End Sub


    ''' <summary>
    ''' tH[Ƃ̏
    ''' <summary>
    ''' <param name="sender"><param>
    ''' <param name="e"><param>
    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles MyBase.FormClosed
        ' tH[JƂAt@CȂꍇ́A}ʂāAt@C폜
        If fileExist = False Then
            Dim doc As Document = app.ActiveDocument
            If doc.FullName = rpcdFilePath Then
                doc.Close()
                File.Delete(rpcdFilePath)
            End If
        End If
    End Sub


    ''' <summary>
    ''' \[Xɖߍ񂾃Tvt@CoĎw肵pXɕۑ
    ''' <summary>
    ''' <param name="saveFilePath">ۑt@C̃tpX<param>
    Private Sub SaveAnimationPartsFile(ByVal saveFilePath As String)
        ' ݎsĂAssembly擾
        Dim asm As System.Reflection.Assembly = Me.GetType().Assembly
        'Dim sss As String() = asm.GetManifestResourceNames() ' AZûׂẴ\[X̖OԂB
        Dim s As System.IO.Stream = asm.GetManifestResourceStream((asm.GetName().Name + ".animationparts.rpcd"))

        Dim read As New BinaryReader(s)
        Dim fs As New FileStream(saveFilePath, FileMode.Create)
        Dim write As New BinaryWriter(fs)

        ' Xg[ǂݏoăt@Cɏ
        Dim bt(s.Length) As Byte
        s.Read(bt, 0, bt.Length)
        write.Write(bt)

        ' N[Y
        s.Close()
        read.Close()
        write.Close()
        fs.Close()
    End Sub



    ''' <summary>
    ''' X^[g{^NbNƂ̏
    ''' <summary>
    ''' <param name="sender"><param>
    ''' <param name="e"><param>
    Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
        '^C}[Ă鎞͎~߂ďI
        If Me.Timer1.Enabled = True Then
            Me.Timer1.Enabled = False
            button1.Text = "Start"
            Return
        End If


        Dim doc As Document = app.ActiveDocument
        Dim drawing As Drawing = doc.CurrentDrawing

        ' Ce[u̎擾
        layerTable = doc.LayerTable
        ' [gC̎擾
        Dim rootLayer As Layer = layerTable.RootLayer
        ' qC̃CRNV擾
        Dim layerCollection As LayerCollection = rootLayer.ChildLayers

        ' JEg_Ep̃C擾
        countdownTextLayer = layerCollection("Countdown")

        ' ˑ̃C擾
        launchingPadLayer = layerCollection("LaunchingPad")
        launchingPadLayer.State = ShapeState.Visible ' \
        ' Pbg̃C(Rocket0)擾
        rocket0Layer = layerCollection("Rocket0")
        ' JgCC(Rocket0)ɂ
        layerTable.CurrentLayer = rocket0Layer

        ' Pbg̃C(Rocket1, Rocket2)擾
        rocketLayer(0) = layerCollection("Rocket1")
        rocketLayer(1) = layerCollection("Rocket2")

        ' ñC擾
        earthLayer = layerCollection("Earth")
        earthLayer.State = ShapeState.NotVisible ' \
        ' ShapeRNV擾
        Dim shapeCollection As ShapeCollection = drawing.Shapes

        ' Aj[VɎg}`ɂꍇ͍폜
        If countdownTextShape IsNot Nothing Then
            shapeCollection.Remove(countdownTextShape)
            countdownTextShape = Nothing
        End If

        ' Pbgɂꍇ͍폜
        For i As Integer = 0 To 1
            If rocketComponentShape(i) IsNot Nothing Then
                shapeCollection.Remove(rocketComponentShape(i))
                rocketComponentShape(i) = Nothing
            End If
        Next

        ' Pbg̍}i(Rocket1, Rocket2)}ʂɔzu
        Dim drawComponentCollection As MasterDrawComponentCollection = doc.MasterDrawComponents
        Dim rocketDrawComponent(1) As MasterDrawComponent
        For i As Integer = 0 To 1
            Dim rocketNo As Integer = i + 1
            Dim componentName As String = "Rocket" + rocketNo.ToString()
            rocketDrawComponent(i) = drawComponentCollection(componentName)
            Dim point1 As Point2d = app.Geometry.CreatePoint(430, 300)
            Dim scaleX As Double = 1.0
            Dim scaleY As Double = 1.0
            Dim locateAngle As Double = 0.0
            rocketComponentShape(i) = drawing.Shapes.AddDrawComponent(rocketDrawComponent(i), point1, scaleX, scaleY, locateAngle, True)
        Next


        '^C}[͓
        currentAnimationIndex = 0
        Me.Timer1.Enabled = True
        button1.Text = "Stop"
    End Sub


    ''' <summary>
    ''' timer1TickCxgnh
    ''' <summary>
    ''' <param name="sender"><param>
    ''' <param name="e"><param>
    Private Sub timer1_Tick_1(ByVal sender As Object, ByVal e As EventArgs) Handles Timer1.Tick
        ChangeAnimationSheet()
    End Sub


    ''' <summary>
    ''' \̐؂ւ
    ''' <summary>
    Private Sub ChangeAnimationSheet()
        Dim doc As Document = app.ActiveDocument
        Dim drawing As Drawing = doc.CurrentDrawing

        currentAnimationIndex += 1

        ' JEg_E
        If currentAnimationIndex <= countdownSecond Then
            ' 1b
            If currentAnimationIndex = 1 Then
                ' JEg_Ep̃CJg
                layerTable.CurrentLayer = countdownTextLayer

                ' ̍쐬
                Dim point1 As Point2d = app.Geometry.CreatePoint(880, 450)
                countdownTextShape = drawing.Shapes.AddText("3", point1, 0.0)
            Else
                ' ̕ύX
                Dim countValue As Integer = 4 - currentAnimationIndex
                countdownTextShape.Text = countValue.ToString()
            End If

            ' Pbg->㏸->n
        Else
            Dim currentLayerIndex As Integer = (currentAnimationIndex - (countdownSecond + 1) Mod 2) Mod 2 ' ŏ0ɂȂ悤
            Dim offsetHigth As Double = 100.0

            ' JgC؂ւ
            layerTable.CurrentLayer = rocketLayer(currentLayerIndex)

            Dim rocketIndex As Integer = currentLayerIndex
            Dim nextRocketIndex As Integer = rocketIndex + 1
            If nextRocketIndex > 1 Then
                nextRocketIndex = 0
            End If
            ' Pbg->㏸
            If currentAnimationIndex <= risingSecond Then
                Dim point1 As Point2d = rocketComponentShape(rocketIndex).Point
                Dim point2 As Point2d = app.Geometry.CreatePoint(point1.X, point1.Y + offsetHigth)
                rocketComponentShape(nextRocketIndex).Point = point2
                ' n
            Else
                If currentAnimationIndex = risingSecond + 1 Then
                    launchingPadLayer.State = ShapeState.NotVisible ' ˑ͔\
                    earthLayer.State = ShapeState.Visible ' n\
                    layerTable.CurrentLayer = earthLayer
                End If

                ' n̒SW(1700, 1700)
                ' N̔a800, 15x(360 / 24)ړ
                Dim positionIndex As Integer = (currentAnimationIndex - (risingSecond + 1)) Mod 24

                Dim rotationAngle As Double = (Math.PI / 12.0) * positionIndex
                Dim x As Double = 1700.0 - 800.0 * Math.Cos(rotationAngle)
                Dim y As Double = 1700.0 + 800.0 * Math.Sin(rotationAngle)

                Dim point1 As Point2d = app.Geometry.CreatePoint(x, y)

                rocketComponentShape(nextRocketIndex).Point = point1
                rocketComponentShape(nextRocketIndex).Angle = 360.0 - 15.0 * positionIndex
            End If
        End If
    End Sub


    ''' <summary>
    ''' Close {^NbNƂ̏
    ''' <summary>
    ''' <param name="sender"><param>
    ''' <param name="e"><param>
    Private Sub button2_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button2.Click
        Me.Close()
    End Sub

End Class